/* Copyright (c) 2000-2006 Wolfgang Hoermann and Josef Leydold */
/* Department of Statistics and Mathematics, WU Wien, Austria  */

#ifndef URNG_SOURCE_H_SEEN
#define URNG_SOURCE_H_SEEN
#if UNUR_URNG_TYPE == UNUR_URNG_GENERIC
#define _unur_call_urng(urng)    ((urng)->sampleunif((urng)->state))
#elif UNUR_URNG_TYPE == UNUR_URNG_FVOID
#define _unur_call_urng(urng)    ((*(urng))())
#define _unur_call_reset(urng) \
 ( (urng)==(unur_urng_MRG31k3p) ? (unur_urng_MRG31k3p_reset()) \
    : ( (urng)==(unur_urng_fish) ? (unur_urng_fish_reset()) \
      : ( (urng)==(unur_urng_mstd) ? (unur_urng_mstd_reset()) \
	  : (UNUR_FAILURE) )))
#elif UNUR_URNG_TYPE == UNUR_URNG_PRNG
#define _unur_call_urng(urng)    (prng_get_next(urng))
#define _unur_call_reset(urng)   (prng_reset(urng),UNUR_SUCCESS)
#elif UNUR_URNG_TYPE == UNUR_URNG_RNGSTREAMS
#define _unur_call_urng(urng)    (RngStream_RandU01(urng))
#define _unur_call_reset(urng)   (RngStream_ResetStartStream(urng),UNUR_SUCCESS)
#elif UNUR_URNG_TYPE == UNUR_URNG_GSL
#define _unur_call_urng(urng)    (gsl_rng_uniform_pos(urng))
#define _unur_call_reset(urng)   (UNUR_FAILURE)
#else
#error UNUR_URNG_TYPE not valid !!
#endif  
#endif  
